# this function controls all the boss timers for specific distorted entities that will have special powers to obliterate you
# this also controls all the bossbars related to these entities

# ELDER GUARDIAN TIMER - 3 unique attacks
scoreboard players add elder_guardian boss_timer 1

# attack 1 - aoe bubbles damage
execute if score elder_guardian boss_timer matches 100 as @e[tag=distorted_elder_guardian] at @s if entity @p[distance=..5] run function distorted_caves:elder_guardian_aoe

# attack 2 - drowned minions
execute if score elder_guardian boss_timer matches 200 as @e[tag=distorted_elder_guardian] at @s run function distorted_caves:elder_guardian_drowned_minions

# attack 3 - heavy arms - resets timer here
execute if score elder_guardian boss_timer matches 500 as @e[tag=distorted_elder_guardian] at @s if entity @p[distance=..10] run function distorted_caves:elder_guardian_heavy_arms
execute if score elder_guardian boss_timer matches 600 run scoreboard players set elder_guardian boss_timer 0


# WITHER TIMER - 5 unique attacks
scoreboard players add wither boss_timer 1

# attack 1 - withering aoe
execute if score wither boss_timer matches 100 as @e[tag=distorted_wither] at @s if entity @p[distance=..5] run function distorted_caves:wither_withering_aoe

# attack 2 - distorted fireballs
execute if score wither boss_timer matches 200 as @e[tag=distorted_wither] at @s if entity @p[distance=..8] run function distorted_caves:wither_distorted_fireballs

# attack 3 - regeneration
execute if score wither boss_timer matches 400 as @e[tag=distorted_wither] at @s run function distorted_caves:wither_regeneration

# attack 4 - wither skeleton minions - reset here
execute if score wither boss_timer matches 500 as @e[tag=distorted_wither] at @s run function distorted_caves:wither_minions
execute if score wither boss_timer matches 600 run scoreboard players set wither boss_timer 0


# SKELETON TIMER
scoreboard players add skeleton boss_timer 1

# basically every 5 seconds, it will shoot out a distorted laser at you
execute if score skeleton boss_timer matches 100 as @a at @s as @e[type=skeleton,tag=distorted_skeleton,distance=..5] at @s anchored eyes run function distorted_caves:skeleton_distorted_laser
execute if score skeleton boss_timer matches 101 run scoreboard players set skeleton boss_timer 0

# PHANTOM TIMER

# when a player is attacked, it will give a slowness effect
execute as @e[type=phantom,tag=distorted_phantom] at @s if entity @p[distance=..1] run function distorted_caves:distorted_phantom_ability


# BOSSBAR FUNCTIONS
execute as @a at @s if entity @e[tag=distorted_elder_guardian,distance=..20] run bossbar set distorted_elder_guardian players @s
execute as @a at @s unless entity @e[tag=distorted_elder_guardian,distance=..20] run bossbar set distorted_elder_guardian players

execute at @a as @e[type=elder_guardian,tag=distorted_elder_guardian,limit=1,sort=nearest,distance=..20] store result bossbar distorted_elder_guardian value run data get entity @s Health